diff -Naur openssl-1.0.0q.orig/ssl/t1_enc.c openssl-1.0.0q/ssl/t1_enc.c
--- openssl-1.0.0q.orig/ssl/t1_enc.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/t1_enc.c	2017-04-25 16:23:41.453030200 +0200
@@ -135,7 +135,11 @@
  * OTHERWISE.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include "ssl_locl.h"
 #ifndef OPENSSL_NO_COMP
 #include <openssl/comp.h>
@@ -161,7 +165,7 @@
 	unsigned int j;
 	HMAC_CTX ctx;
 	HMAC_CTX ctx_tmp;
-	unsigned char A1[EVP_MAX_MD_SIZE];
+	unsigned char A1[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-09-14 alexeik */
 	unsigned int A1_len;
 	int ret = 0;
 	
@@ -174,15 +178,15 @@
 		goto err;
 	if (!HMAC_Init_ex(&ctx_tmp,sec,sec_len,md, NULL))
 		goto err;
-	if (seed1 != NULL && !HMAC_Update(&ctx,seed1,seed1_len))
+	if (seed1 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed1,seed1_len))
 		goto err;
-	if (seed2 != NULL && !HMAC_Update(&ctx,seed2,seed2_len))
+	if (seed2 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed2,seed2_len))
 		goto err;
-	if (seed3 != NULL && !HMAC_Update(&ctx,seed3,seed3_len))
+	if (seed3 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed3,seed3_len))
 		goto err;
-	if (seed4 != NULL && !HMAC_Update(&ctx,seed4,seed4_len))
+	if (seed4 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed4,seed4_len))
 		goto err;
-	if (seed5 != NULL && !HMAC_Update(&ctx,seed5,seed5_len))
+	if (seed5 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed5,seed5_len))
 		goto err;
 	if (!HMAC_Final(&ctx,A1,&A1_len))
 		goto err;
@@ -197,15 +201,15 @@
 			goto err;
 		if (!HMAC_Update(&ctx_tmp,A1,A1_len))
 			goto err;
-		if (seed1 != NULL && !HMAC_Update(&ctx,seed1,seed1_len))
+		if (seed1 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed1,seed1_len))
 			goto err;
-		if (seed2 != NULL && !HMAC_Update(&ctx,seed2,seed2_len))
+		if (seed2 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed2,seed2_len))
 			goto err;
-		if (seed3 != NULL && !HMAC_Update(&ctx,seed3,seed3_len))
+		if (seed3 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed3,seed3_len))
 			goto err;
-		if (seed4 != NULL && !HMAC_Update(&ctx,seed4,seed4_len))
+		if (seed4 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed4,seed4_len))
 			goto err;
-		if (seed5 != NULL && !HMAC_Update(&ctx,seed5,seed5_len))
+		if (seed5 != NULL && !HMAC_Update(&ctx,(const unsigned char *)seed5,seed5_len))
 			goto err;
 
 		if (olen > chunk)
@@ -363,7 +367,7 @@
 
 		if (s->enc_read_ctx != NULL)
 			reuse_dd = 1;
-		else if ((s->enc_read_ctx=OPENSSL_malloc(sizeof(EVP_CIPHER_CTX))) == NULL)
+		else if ((s->enc_read_ctx=(EVP_CIPHER_CTX *)OPENSSL_malloc(sizeof(EVP_CIPHER_CTX))) == NULL)
 			goto err;
 		else
 			/* make sure it's intialized in case we exit later with an error */
@@ -693,7 +697,7 @@
 
 	if ((s->session == NULL) || (ds == NULL) || (enc == NULL))
 		{
-		memmove(rec->data,rec->input,rec->length);
+		op_memmove(rec->data,rec->input,rec->length);
 		rec->input=rec->data;
 		ret = 1;
 		}
@@ -897,7 +901,7 @@
 		unsigned char dtlsseq[8],*p=dtlsseq;
 
 		s2n(send?ssl->d1->w_epoch:ssl->d1->r_epoch, p);
-		memcpy (p,&seq[2],6);
+		op_memcpy (p,&seq[2],6);
 
 		memcpy(header, dtlsseq, 8);
 		}
@@ -966,7 +970,7 @@
 int tls1_generate_master_secret(SSL *s, unsigned char *out, unsigned char *p,
 	     int len)
 	{
-	unsigned char buff[SSL_MAX_MASTER_KEY_LENGTH];
+	unsigned char buff[SSL_MAX_MASTER_KEY_LENGTH]; /* ARRAY OK 2009-09-14 alexeik */
 	const void *co = NULL, *so = NULL;
 	int col = 0, sol = 0;
 
diff -Naur openssl-1.0.0q.orig/ssl/t1_lib.c openssl-1.0.0q/ssl/t1_lib.c
--- openssl-1.0.0q.orig/ssl/t1_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/t1_lib.c	2017-04-25 16:23:41.454030048 +0200
@@ -109,7 +109,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include <openssl/hmac.h>
@@ -312,7 +316,7 @@
 		/* hostname type, length and hostname */
 		*(ret++) = (unsigned char) TLSEXT_NAMETYPE_host_name;
 		s2n(size_str,ret);
-		memcpy(ret, s->tlsext_hostname, size_str);
+		op_memcpy(ret, s->tlsext_hostname, size_str);
 		ret+=size_str;
 		}
 
@@ -397,7 +401,7 @@
 			 s->tlsext_session_ticket->data)
 			{
 			ticklen = s->tlsext_session_ticket->length;
-			s->session->tlsext_tick = OPENSSL_malloc(ticklen);
+			s->session->tlsext_tick = (unsigned char*)OPENSSL_malloc(ticklen);
 			if (!s->session->tlsext_tick)
 				return NULL;
 			memcpy(s->session->tlsext_tick,
@@ -418,7 +422,7 @@
 		s2n(ticklen,ret);
 		if (ticklen)
 			{
-			memcpy(ret, s->session->tlsext_tick, ticklen);
+			op_memcpy(ret, s->session->tlsext_tick, ticklen);
 			ret += ticklen;
 			}
 		}
@@ -811,14 +815,14 @@
 							*al = TLS1_AD_UNRECOGNIZED_NAME;
 							return 0;
 							}
-						if ((s->session->tlsext_hostname = OPENSSL_malloc(len+1)) == NULL)
+						if ((s->session->tlsext_hostname = (char *)OPENSSL_malloc(len+1)) == NULL)
 							{
 							*al = TLS1_AD_INTERNAL_ERROR;
 							return 0;
 							}
-						memcpy(s->session->tlsext_hostname, sdata, len);
+						op_memcpy(s->session->tlsext_hostname, sdata, len);
 						s->session->tlsext_hostname[len]='\0';
-						if (strlen(s->session->tlsext_hostname) != len) {
+						if (op_strlen(s->session->tlsext_hostname) != len) {
 							OPENSSL_free(s->session->tlsext_hostname);
 							s->session->tlsext_hostname = NULL;
 							*al = TLS1_AD_UNRECOGNIZED_NAME;
@@ -1783,7 +1787,7 @@
 	unsigned char *sdec;
 	const unsigned char *p;
 	int slen, mlen, renew_ticket = 0;
-	unsigned char tick_hmac[EVP_MAX_MD_SIZE];
+	unsigned char tick_hmac[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-09-15 alexeik */
 	HMAC_CTX hctx;
 	EVP_CIPHER_CTX ctx;
 	SSL_CTX *tctx = s->initial_ctx;
@@ -1829,7 +1833,7 @@
 	HMAC_Update(&hctx, etick, eticklen);
 	HMAC_Final(&hctx, tick_hmac, NULL);
 	HMAC_CTX_cleanup(&hctx);
-	if (CRYPTO_memcmp(tick_hmac, etick + eticklen, mlen))
+	if (op_memcmp(tick_hmac, etick + eticklen, mlen))
 		{
 		EVP_CIPHER_CTX_cleanup(&ctx);
 		goto tickerr;
@@ -1838,7 +1842,7 @@
 	/* Move p after IV to start of encrypted ticket, update length */
 	p = etick + 16 + EVP_CIPHER_CTX_iv_length(&ctx);
 	eticklen -= 16 + EVP_CIPHER_CTX_iv_length(&ctx);
-	sdec = OPENSSL_malloc(eticklen);
+	sdec = (unsigned char*)OPENSSL_malloc(eticklen);
 	if (!sdec)
 		{
 		EVP_CIPHER_CTX_cleanup(&ctx);
@@ -1865,7 +1869,7 @@
  		 * as required by standard.
  		 */
 		if (sesslen)
-			memcpy(sess->session_id, sess_id, sesslen);
+			op_memcpy(sess->session_id, sess_id, sesslen);
 		sess->session_id_length = sesslen;
 		*psess = sess;
 		s->tlsext_ticket_expected = renew_ticket;
diff -Naur openssl-1.0.0q.orig/ssl/tls1.h openssl-1.0.0q/ssl/tls1.h
--- openssl-1.0.0q.orig/ssl/tls1.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/ssl/tls1.h	2017-04-25 16:23:41.455030175 +0200
@@ -220,7 +220,7 @@
 #if 0 /* will have to be provided externally for now ,
        * i.e. build with -DTLSEXT_TYPE_opaque_prf_input=38183
        * using whatever extension number you'd like to try */
-# define TLSEXT_TYPE_opaque_prf_input		?? */
+# define TLSEXT_TYPE_opaque_prf_input		??
 #endif
 
 /* Temporary extension type */
